// $Id: PerlInterpreterStub.C,v 1.1 2001/12/26 03:28:36 nolanw Exp $
// $Author: nolanw $

#include <PerlInterpreterStub.H>

PerlInterpreter *my_perl = 0;	// mmmmmm, global variable
PerlInterpreterStub *PerlInterpreterStub::_instance = 0;

PerlInterpreterStub::PerlInterpreterStub() {}

PerlInterpreterStub::~PerlInterpreterStub() {
  if(my_perl) {					// clean up (allocated) instance of interp.
	perl_destruct(my_perl);
	perl_free(my_perl);
  }
}

PerlInterpreterStub *PerlInterpreterStub::instance()
{
  if(_instance == 0) {
	_instance = new PerlInterpreterStub();	 
  }
  return _instance;
}

void PerlInterpreterStub::loadInterpreter(char **env_)
{
  static char *embedding[] = {"", "-e", ""};
  
  if(my_perl == 0) {			// allocate instance of interpreter
	my_perl = perl_alloc();
	perl_construct(my_perl);
	perl_parse(my_perl, NULL, 3, embedding, env_);
  }
}
